import { ElementType, useCallback } from "react";
import { useAppDispatch } from "../../hooks";

export type UpsertModelHandler = (e: any, setUpsertModel: any) => void;

export const WithForm = (Component: ElementType) => {
  return function WithFormComponent({ ...props }: {
    [key: string]: any;
  }) {
    const dispatch = useAppDispatch();

    const dispatchFormData: UpsertModelHandler = useCallback((
      { currentTarget }: any,
      setUpsertModel: any
    ) => {
      const data: any = {};

      for (const input of currentTarget.elements) {
        if (input.name !== null && input.name !== '') {
          data[input.name] = input.value;
        }
      };

      dispatch(setUpsertModel({
        data: {
          attributes: data,
        },
      }));
    }, [dispatch]);

    props = {
      handleUpsertModel: (e: any, setUpsertModel: any) => {
        e.preventDefault();
        dispatchFormData(e, setUpsertModel);
      },
      ...props,
    };

    return <Component {...props} />;
  };
};
